%
% D:\Studies\NHP\Card3
% compute_1PRYsq_trans2.m
%
% 1. Project the vertices onto the supplied fitting matrix.
% 2. Calculate the resulted Pitch Roll Yaw.
% 
% 
% 
% HSUNG Tai-Chiu, Richard.
% July 4, 2013.
function [Vuvec, Huvec, vaxisv, haxisv, mean_vall] = compute_1PRYsq_trans3(vh, vv, iXvec,iYvec, figno)

% bbx=[0 0 -5; 0 0 5];
% 
% All_Vuvec = [0 0 0];
% All_Huvec = [0 0 0];

color = {'b','c','y'};

% m2=iYvec;
m2=iYvec/sqrt(iYvec*iYvec');
m1=iXvec-(m2*iXvec')/(m2*m2')*m2;   m1=m1/sqrt(m1*m1');

% spanvec = [ iVvec; iHvec ]
spanvec=[m1;m2];
% FitMatrix = fm
FitMatrix = [spanvec; null(spanvec)'];
% FitMatrix*FitMatrix'

mean_vall = mean([vh;vv]);

vaxisv = [vv(:,1)-mean_vall(1) vv(:,2)-mean_vall(2) vv(:,3)-mean_vall(3)]*FitMatrix';
haxisv = [vh(:,1)-mean_vall(1) vh(:,2)-mean_vall(2) vh(:,3)-mean_vall(3)]*FitMatrix';

% vaxisv = (vv2*(tr_roll'))';
% haxisv = (vh2*(tr_roll'))';

    
	% Vertical
% 	vaxisv = vv;
	
	% Horizontal
% 	haxisv = vh;

if (figno>0)
    figure(figno);
    plot3(vaxisv(:,1),vaxisv(:,2),vaxisv(:,3),[color{1} '.'])
    plot3(haxisv(:,1),haxisv(:,2),haxisv(:,3),[color{1} 'o'])
end

[Vuvec, Huvec] = compute_1PRYsq(haxisv, vaxisv, figno);
% 
%     % Fit vertical axis!
%     mean_vaxis = mean(vaxisv);
% 
%     % Range
%     xxx = [vaxisv(:,1);haxisv(:,1)];
%     yyy = [vaxisv(:,2);haxisv(:,2)];
%     hlimit = ([min(xxx) max(xxx)]);
%     vlimit = ([min(yyy) max(yyy)]);
% 
%     
%     A=[vaxisv(:,1)-mean_vaxis(1) vaxisv(:,2)-mean_vaxis(2) vaxisv(:,3)-mean_vaxis(3)];
%     [u,s,v]=svd(A);
% %     diag(s)
%     Vunitvec=v(:,1)';
%     scale_v = (vlimit-mean_vaxis(2))/Vunitvec(2);
%     theVPoints=[Vunitvec*scale_v(1); Vunitvec*scale_v(2)]+[mean_vaxis;mean_vaxis];
% if (figno>0)
%     plot3(theVPoints(:,1),theVPoints(:,2),theVPoints(:,3), [color{2} '-']);
% end
%     Vuvec = Vunitvec;
% %     All_Vuvec(r+1,:) = Vunitvec;
%     
%     % Fit horizontal axis!
%     mean_haxis = mean(haxisv);
%     
%     B=[haxisv(:,1)-mean_haxis(1) haxisv(:,2)-mean_haxis(2) haxisv(:,3)-mean_haxis(3)];
%     [u,s,v]=svd(B);
% %     diag(s)
%     Hunitvec=v(:,1)';
%     scale_h = (hlimit-mean_haxis(1))/Hunitvec(1);
%     theHPoints=[Hunitvec*scale_h(1); Hunitvec*scale_h(2)]+[mean_haxis;mean_haxis];
% if (figno>0)
%     plot3(theHPoints(:,1),theHPoints(:,2),theHPoints(:,3), [color{3} '-']);
% end
%     Huvec = Hunitvec;
%     
