%
% D:\Studies\NHP-Ref\ml\correct_mesh.m
%
% 1. Project the vertices onto the supplied fitting matrix.
% 2. Calculate the resulted Pitch Roll Yaw.
% 
% 
% 
% HSUNG Tai-Chiu, Richard.
% Jan 10, 2014.
% 
function [vv2, mean_vall] = trans3_with_XYaxes(vv, iXvec,iYvec, figno)

m2=iYvec/sqrt(iYvec*iYvec');
m1=iXvec-(m2*iXvec')/(m2*m2')*m2;   m1=m1/sqrt(m1*m1');

spanvec=[m1;m2];
FitMatrix = [spanvec; null(spanvec)'];
% FitMatrix*FitMatrix'

mean_vall = mean([vv]);

vv2 = [vv(:,1)-mean_vall(1) vv(:,2)-mean_vall(2) vv(:,3)-mean_vall(3)]*FitMatrix';


if (figno>0)
    figure(figno);
    plot3(vv2(:,1),vv2(:,2),vv2(:,3),'b.')
end

return